Option Strict Off
Option Explicit On 
Module ZeroMem

    Sub StrCopy(ByRef dest() As Byte, ByVal src As String)
        Dim i As Integer
        For i = 1 To Len(src)
            dest(i) = Asc(Mid(src, i, 1))
        Next
    End Sub

    Public Sub CopyTable(ByRef Dest() As Byte, ByVal Src() As Byte, ByVal OffsetDest As Integer, ByVal OffsetSrc As Integer, ByVal Count As Integer)        
        While Count <> 0
            Count = Count - 1
            Dest(Count + OffsetDest) = Src(Count + OffsetSrc)            
        End While
    End Sub

    Public Sub ZeroMemory(ByRef tData() As Byte, ByVal Count As Integer, ByVal Offset As Integer)
        Count = Count - 1
        While (Count >= 0)
            tData(Count + Offset) = 0
            Count = Count - 1
        End While
    End Sub

    Public Sub Print16(ByVal Data() As Byte)
        Dim n As Byte
        Dim stmp As String
        n = 0
        While (n < 16)
            stmp = IntToHex(Data(n), 2) + " "
            System.Console.Write(stmp)
            n = n + 1
        End While
        System.Console.WriteLine("")
    End Sub

    Public Function IntToHex(ByVal i As Long, ByVal Count As Byte) As String
        Dim t As Integer
        Dim s As String

        s = Hex(i)
        If Len(s) + 1 > Count Then
            IntToHex = s
            Exit Function
        End If
        For t = Len(s) + 1 To Count
            s = "0" + s
        Next

        IntToHex = s
    End Function

End Module